您的位置:首页 > 其它

leetcode 633. Sum of Square Numbers 二分查找+勾股定理

2017-12-19 20:48 555 查看
Given a non-negative integer c, your task is to decide whether there’re two integers a and b such that a2 + b2 = c.

Example 1:

Input: 5

Output: True

Explanation: 1 * 1 + 2 * 2 = 5

Example 2:

Input: 3

Output: False

本题很简单,就是寻找勾股数,我最初的想法是直接暴力求解但是发现太笨了,后来在网上看到了一个二分查找的做法,十分棒,值得学习

代码如下:

#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <stack>
#include <string>
#include <climits>
#include <algorithm>
#include <sstream>
#include <functional>
#include <bitset>
#include <numeric>
#include <cmath>
#include <regex>

using namespace std;

class Solution
{
public:
bool judgeSquareSum(int c)
{
if (c < 0)
return false;
int left = 0, right = (int)sqrt(c);
while (left <= right)
{
int res = left*left + right*right;
if (res < c)
left++;
else if (res > c)
right--;
else
return true;
}
return false;
}
};
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: